package com.gmail.berndivader.animatorstands.mechanics;

import org.bukkit.Location;

import com.gmail.berndivader.animatorstands.ArmorStandAnimator;
import com.gmail.berndivader.animatorstands.ArmorStandUtils;

import io.lumine.mythic.api.adapters.AbstractEntity;
import io.lumine.mythic.api.adapters.AbstractLocation;
import io.lumine.mythic.api.config.MythicLineConfig;
import io.lumine.mythic.api.skills.ITargetedEntitySkill;
import io.lumine.mythic.api.skills.ITargetedLocationSkill;
import io.lumine.mythic.api.skills.SkillMetadata;
import io.lumine.mythic.api.skills.SkillResult;
import io.lumine.mythic.bukkit.BukkitAdapter;
import io.lumine.mythic.core.skills.SkillMechanic;

public class ArmorStandLookAtMechanic extends SkillMechanic implements ITargetedEntitySkill, ITargetedLocationSkill {
	
	public ArmorStandLookAtMechanic(SkillMechanic skill, MythicLineConfig mlc) {
		super(skill.getManager(),skill.getFile(),mlc.getLine(), mlc);
		this.setAsyncSafe(false);
	}

	@Override
	public SkillResult castAtLocation(SkillMetadata data, AbstractLocation target) {
		ArmorStandAnimator e = ArmorStandUtils.getAnimatorInstance(data.getCaster().getEntity());
		if (e==null) return SkillResult.ERROR;
		Location l = ArmorStandUtils.lookAt(e.getArmorStand().getLocation(), BukkitAdapter.adapt(target));
		ArmorStandUtils.nmsEntity.setEntityRotation(BukkitAdapter.adapt(e.getArmorStand()), l.getYaw(), l.getPitch());
		return SkillResult.SUCCESS;
	}

	@Override
	public SkillResult castAtEntity(SkillMetadata data, AbstractEntity target) {
		return castAtLocation(data, target.getLocation());
	}

}
