package com.gmail.berndivader.animatorstands.mechanics;

import com.gmail.berndivader.animatorstands.ArmorStandUtils;

import io.lumine.mythic.api.adapters.AbstractEntity;
import io.lumine.mythic.api.config.MythicLineConfig;
import io.lumine.mythic.api.skills.INoTargetSkill;
import io.lumine.mythic.api.skills.ITargetedEntitySkill;
import io.lumine.mythic.api.skills.SkillMetadata;
import io.lumine.mythic.api.skills.SkillResult;
import io.lumine.mythic.core.skills.SkillMechanic;

public class ArmorStandRunMechanic extends SkillMechanic implements INoTargetSkill, ITargetedEntitySkill {

	public ArmorStandRunMechanic(SkillMechanic skill, MythicLineConfig mlc) {
		super(skill.getManager(),skill.getFile(),mlc.getLine(), mlc);
		this.setAsyncSafe(false);
	}

	@Override
	public SkillResult castAtEntity(SkillMetadata data, AbstractEntity target) {
		ArmorStandUtils.startArmorStandAnimation(target);
		return SkillResult.SUCCESS;
	}

	@Override
	public SkillResult cast(SkillMetadata data) {
		ArmorStandUtils.startArmorStandAnimation(data.getCaster().getEntity());
		return SkillResult.SUCCESS;
	}
}
